package org.one.stone.soup.entity;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

public class KeyValuePair {

	public static final int ASCENDING = 1;
	public static final int DESCENDING = -1;	
	
	public String key;
	public String value;

	public static Vector createKeyValuePairVector(Hashtable list)
	{
		Vector newList = new Vector();
		
		Enumeration keys = list.keys();
		while(keys.hasMoreElements())
		{
			Object key = keys.nextElement();
			String keyName = key.toString();
			String value = list.get(key).toString();
			
			newList.addElement( new KeyValuePair(keyName,value) );
		}
		
		return newList;
	}
	
	public KeyValuePair(String key,String value)
	{
		this.key = key;
		this.value = value;
	}
	
	public static KeyValuePair parseKeyValuePair(String data,String separator)
	{
		if( data.indexOf(separator)==-1 )
		{
			return null;
		}
		
		String value = data.substring(data.indexOf(separator)+separator.length());
		String key = data.substring(0,data.indexOf(separator));
		
		return new KeyValuePair(key,value);
	}
	
	public String toString()
	{
		return key;
	}

	public static final Vector applyIndex(Vector list, int[] index) {
	
		//System.out.println("applyIndex");
	
		int size = list.size();
		if(index.length!=size)
			throw(new ArrayIndexOutOfBoundsException());
	
		Vector newList = new Vector();
		int loop;
		for(loop=0;loop<size;loop++)
			newList.addElement( list.elementAt(index[loop]) );
	
		return newList;
	}

	public final static int[] createIndex(Vector list,int direction) {
	
		//System.out.println("createIndex");
	
		int size=list.size();
	
		if(size==0)
			return new int[0];
	
		if(direction!=ASCENDING && direction!=DESCENDING)
			return new int[list.size()];
	
		int[] index = new int[size];
		boolean[] indexed = new boolean[size];
	
		int loop;
		for(loop=0;loop<size;loop++)
			indexed[loop]=false;
	
		int loop2;
		int foundIndex;
		String foundObj;
		for(loop=0;loop<size;loop++)
		{
			//System.out.println("createIndex:"+loop);
	
			foundIndex=0;
			foundObj = null;
	
			for(loop2=0;loop2<size;loop2++)
			{
				//System.out.println("createIndex2:"+loop);
	
				if(indexed[loop2]==true)
					continue;
	
				if(foundObj==null)
				{
					foundObj=((KeyValuePair)list.elementAt(loop2)).key;
					foundIndex=loop2;
					continue;
				}
	
				if(direction==ASCENDING)
				{
					if(foundObj.compareTo(((KeyValuePair)list.elementAt(loop2)).key)>0)
					{
						foundObj=((KeyValuePair)list.elementAt(loop2)).key;
						foundIndex=loop2;
					}
				}
				else
				{
					if(foundObj.compareTo(((KeyValuePair)list.elementAt(loop2)).key)<0)
					{
						foundObj=((KeyValuePair)list.elementAt(loop2)).key;
						foundIndex=loop2;
					}
				}
			}
	//		System.out.println("Indexed "+loop+" -> "+foundIndex+" = "+(String)data.elementAt(foundIndex));
			indexed[foundIndex]=true;
			index[loop]=foundIndex;
		}
	//	System.out.println("Index created");
	
		//System.out.println("createIndex done");
	
		return index;
	}

	public static final Vector sort(Vector list,int direction) {
		return applyIndex(list,createIndex(list,direction));
	}
}
