package org.one.stone.soup.mjdb.data.field;

/*
 * MJDB (Micro Java Database) Version 1.0
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.com/licence/license-os.html
 */

/**
	* The NulField class is a wrapper for a null value.
	* @author Nik Cross
*/

public class NullField extends Field {
	public static String DEFAULT_ID = "_Null";

	public static final NullField NULL = new NullField();
/**
 * Not used in a NullField.
 */
public int compare(Field target) throws CompareException {
	return 0;
}
/**
 * Returns null.
 */
public String getValue(String name) {
	return null;
}
public String toString() {
	return "null";
}
}
