package org.one.stone.soup.mjdb.data.field;

import java.util.*;

/*
 * MJDB (Micro Java Database) Version 1.0
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.com/licence/license-os.html
 */

/**
	* The VectorField class is a wrapper for a Vector of values.
	* @author Nik Cross
*/

public class VectorField extends Field {
	public static String DEFAULT_ID = "_Vector";

	private Vector vector = new Vector();

public void add(Field object,Object source) throws LockException {

	if(locked)
		throw new LockException(this+"is locked");

	vector.addElement(object);
	setChanged();

	if(report)
		reportChange(source);
}
/**
 * compare method comment.
 */
public int compare(Field target) throws CompareException {
	return 0;
}
public Field get(int index) {
	return (Field)vector.elementAt(index);
}
/**
 * getValue method comment.
 */
public String getValue(String name) {
	return null;
}
public void insert(Field object,int index,Object source) throws LockException {

	if(locked)
		throw new LockException(this+"is locked");

	vector.insertElementAt(object,index);
	setChanged();

	if(report)
		reportChange(source);
}
public void remove(Field object,Object source) throws LockException{

	if(locked)
		throw new LockException(this+"is locked");

	vector.removeElement(object);
	setChanged();

	if(report)
		reportChange(source);
}
public void resetChanged() {
	super.resetChanged();

	for(int loop=0;loop<size();loop++)
	{
		get(loop).resetChanged();
	}
}
public void set(int index,Field object,Object source) throws LockException {

	if(locked && !isLockOwner(source))
		throw new LockException(this+"is locked");

	vector.setElementAt(object,index);
	setChanged();

	if(report)
		reportChange(source);
}
/**
 * setValue method comment.
 */
public void setValue(String name, String value, Object source) throws LockException {}
/**
 * Insert the method's description here.
 * Creation date: (23/07/00 11:07:12)
 * @param object org.one.stone.soup.igml.IGMLObject
 */
public int size() {
	return vector.size();
}
}
