package org.one.stone.soup.mjdb.helper;

import java.io.*;
import org.one.stone.soup.mjdb.data.persistence.*;
import org.one.stone.soup.file.*;
import org.one.stone.soup.mjdb.data.field.*;
import org.one.stone.soup.mjdb.data.group.*;

/**
 * Insert the type's description here.
 * Creation date: (31/05/03 19:55:39)
 * @author:
 */
public class DatabaseReloader implements Runnable,FileChangeListener,FieldListener
{
	private Database db;
	private int refreshTime;
	private boolean paused = false;
	private boolean repause = false;
/**
 * DatabaseReloader constructor comment.
 */
public DatabaseReloader(Database db,int refreshTime) {
	super();

	this.db = db;
	this.refreshTime = refreshTime;

	initialize();
}
public void fileChanged(java.io.File file)
{
	if(paused)
	{
		return;
	}

	String changedFileName = file.getPath().replace('\\','/');

	for(int loop=0;loop<db.getNoOfRows();loop++)
	{
		String fileName = db.getPath()+db.getRow(loop).getField(Database.TABLE_FILE).toString();

		if(fileName.equals(changedFileName))
		{
			try{
				java.io.FileInputStream iStream = new java.io.FileInputStream(file);
				CsvToTable csv = new CsvToTable( iStream );
				iStream.close();

				db.getRow(loop).setField(Database.TABLE,csv.getTable(),this);

				break;
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
		}
	}
}
/**
 * Insert the method's description here.
 * Creation date: (31/05/03 19:59:28)
 */
private void initialize()
{
	db.addListener(this);

	FilesWatch fileWatch = new FilesWatch( db.getPath()+db.getFileName(),refreshTime );

	for(int loop=0;loop<db.getNoOfRows();loop++)
	{
		String fileName = db.getRow(loop).getField(Database.TABLE_FILE).toString();

		fileWatch.addFile( new File(db.getPath()+fileName) );
	}

	fileWatch.addListener(this);
}
/**
 * Called when a Field that the FieldListener is listening to has its value
 * changed.
 * @param source	The object that has caused the change
 * @param data		The object that has been changed
 */
public void receiveChange(java.lang.Object source, java.lang.Object data)
{
	if(!paused)
	{
		new Thread(this,"DatabaseReloader paused").start();
	}
	else
	{
		repause = true;
	}
}
	/**
	 * When an object implementing interface <code>Runnable</code> is used
	 * to create a thread, starting the thread causes the object's
	 * <code>run</code> method to be called in that separately executing
	 * thread.
	 * <p>
	 * The general contract of the method <code>run</code> is that it may
	 * take any action whatsoever.
	 *
	 * @see     java.lang.Thread#run()
	 */
public void run()
{
	paused = true;
	repause=true;

	while(repause==true)
	{
		repause=false;
		try{Thread.sleep(refreshTime*2);}catch(Exception e){ e.printStackTrace(); }
	}

	paused = false;
}
}
