/*
 * Created on 10-May-2004
 *
 * Fix to allow use of xui with JVMs before 1.4
 */
package org.one.stone.soup.xapp.swing.components;

import java.io.*;
import java.net.*;
import javax.swing.*;
import javax.swing.text.DefaultFormatter;

import org.one.stone.soup.xapp.components.XappTextFormatter;


/**
 * @author nikcross
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class XappSwingTextFormatter implements XappTextFormatter {

	public static boolean isAvailable()
	{
		try{
			JFormattedTextField field = new JFormattedTextField();
		}
		catch(Exception e)
		{
			return false;
		}
		return true;
	}

	public static JTextField formatText(String format,String data,Integer size)
	{
		DefaultFormatter formatter = new DefaultFormatter();
		formatter.setOverwriteMode(false);
		//formatter.set
		JFormattedTextField fText = new JFormattedTextField(formatter);

		XSwingInputVerifier verifier = new XSwingInputVerifier(format);
		fText.setInputVerifier( verifier );

		if(format.equals( "number" ))
		{
			try{
				fText.setValue( new Float( data ) );
			}
			catch(Exception e)
			{
				fText.setValue( new Float(0) );
			}
		}
		else if(format.equals( "integer" ))
		{
			try{
				fText.setValue( new Integer( data ) );
			}
			catch(Exception e)
			{
				fText.setValue( new Integer(0) );
			}
		}
		else if(format.equals( "file" ))
		{
			try{
				fText.setValue( new File( data ) );
			}
			catch(Exception e)
			{
				fText.setValue( new File("./") );
			}
		}
		else if(format.equals( "url" ))
		{
			try{
				fText.setValue( new URL( data ) );
			}
			catch(Exception e)
			{
				try{
					fText.setValue( new URL("http://wet-wired.com") );
				}
				catch(Exception ue)
				{

				}
			}
		}
		else
		{
			if(data!=null)
			{
				fText.setValue( data );
			}
			else
			{
				fText.setValue( "" );
			}
		}
		fText.setColumns(size.intValue());

		return fText;
	}
}
