package org.one.stone.soup.xml;

/*
 * Wet-Wired.com Xml Version Date 25-Aug-2004
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

// TODO


public class XmlParserSettings {

	public static int TRIM				=1;
	public static int REMOVE_QUOTES		=2;
	public static int ADD_END_OF_LINE	=4;
	public static int DISCARD_COMMENTS	=8;
	public static int ALLOW_IMPORT_TAGS	=16;
	public static int XML_COMPLIENT		=32;
	public static int AUTO_CLOSE_TAGS	=64;
	public static int REPLACE_TABS		=128;

	public boolean trim; // remove white space from between tags
	public boolean removeQuotes; // use quotes to allow leading and trailing white space and '[' , ']' , '<' ,'>'
									// characters but remove them from the value
	public boolean addEndOfLine; // add CR LF to end of xml value lines
	public boolean discardComments; // discard tags starting !--<space>
	public boolean allowImportTags; // use the <import ...> tag to insert other files
	public boolean xmlComplient; // add prefix <?xml version="1.0">
	public boolean autoCloseTags; // close tags that have not been closed before the outer tag is closed
	public boolean replaceTabs; // replace tabs with 4 spaces in values

	public int mask;
public XmlParserSettings(int mask) {

	this.mask = mask;

	if((mask & TRIM) ==0)
		trim=false;
	else
		trim=true;

	if((mask & REMOVE_QUOTES) ==0)
		removeQuotes=false;
	else
		removeQuotes=true;

	if((mask & ADD_END_OF_LINE) ==0)
		addEndOfLine=false;
	else
		addEndOfLine=true;

	if((mask & DISCARD_COMMENTS) ==0)
		discardComments=false;
	else
		discardComments=true;

	if((mask & ALLOW_IMPORT_TAGS) ==0)
		allowImportTags=false;
	else
		allowImportTags=true;

	if((mask & XML_COMPLIENT) ==0)
		xmlComplient=false;
	else
		xmlComplient=true;

	if((mask & AUTO_CLOSE_TAGS) ==0)
		autoCloseTags=false;
	else
		autoCloseTags=true;

	if((mask & REPLACE_TABS) ==0)
		replaceTabs=false;
	else
		replaceTabs=true;
}
/**
 *
 * @return java.lang.String
 */
public String toString() {
	String state="Xml Settings:\n";

	if(trim)
		state+=" trim              ON\n";
	else
		state+=" trim              OFF\n";
	if(removeQuotes)
		state+=" remove quotes     ON\n";
	else
		state+=" remove quotes     OFF\n";
	if(addEndOfLine)
		state+=" add end of line   ON\n";
	else
		state+=" add end of line   OFF\n";
	if(discardComments)
		state+=" discard comments  ON\n";
	else
		state+=" discard comments  OFF\n";
	if(allowImportTags)
		state+=" allow import tags ON\n";
	else
		state+=" allow import tags OFF\n";
	if(xmlComplient)
		state+=" xml complient     ON\n";
	else
		state+=" xml complient     OFF\n";
	if(autoCloseTags)
		state+=" auto close tags   ON\n";
	else
		state+=" auto close tags   OFF\n";
	if(replaceTabs)
		state+=" replace tabs   ON\n";
	else
		state+=" replace tabs   OFF\n";

	return state;
}
}
