package org.one.stone.soup.xml.conditionals;

import java.util.Hashtable;

import org.one.stone.soup.xml.XmlElement;

public class XmlCondition {

	public static String OR = "or";
	public static String AND = "and";
	public static String NOT = "not";
	
	private static Hashtable processors = new Hashtable();
	static{
		processors.put("boolean",new BooleanProcessor());
		processors.put("regexp",new RegExpProcessor());
	}
	
	public static boolean isTrue(XmlElement condition)
	{
		boolean state = false;
		
		boolean[] states = null;
		if(condition.getName().equals(OR))
		{
			states = getConditions( condition );
			for(int loop=0;loop<states.length;loop++)
			{
				if(states[loop]==true)
				{
					state=true;
				}
			}
		}
		else if(condition.getName().equals(AND))
		{
			states = getConditions( condition );
			boolean andState=true;
			for(int loop=0;loop<states.length;loop++)
			{
				if(states[loop]==false)
				{
					andState=false;
				}
			}
			state = andState;
		}
		else if(condition.getName().equals(NOT))
		{
			if(condition.getElementCount()!=1)
			{
				state=false;
			}
			else
			{
				state = ! isTrue(condition.getElementByIndex(0)); 
			}
		}
		else
		{
			String processor = condition.getAttributeValueByName("processor");
			state = ((XmlConditionProcessor)processors.get(processor)).isTrue(condition);
		}
		return state;
	}
	
	public static boolean isTrue(XmlElement condition,XmlConditionProcessor processor)
	{
		boolean state = false;
		
		boolean[] states = null;
		if(condition.getName().equals(OR))
		{
			states = getConditions( condition,processor );
			for(int loop=0;loop<states.length;loop++)
			{
				if(states[loop]==true)
				{
					state=true;
				}
			}
		}
		else if(condition.getName().equals(AND))
		{
			states = getConditions( condition,processor );
			boolean andState=true;
			for(int loop=0;loop<states.length;loop++)
			{
				if(states[loop]==false)
				{
					andState=false;
				}
			}
			state = andState;
		}
		else if(condition.getName().equals(NOT))
		{
			if(condition.getElementCount()!=1)
			{
				state=false;
			}
			else
			{
				state = ! isTrue(condition.getElementByIndex(0),processor); 
			}
		}
		else
		{
			state = processor.isTrue(condition);
		}
		return state;
	}
	
	public static boolean[] getConditions(XmlElement condition)
	{
		boolean[] results = new boolean[ condition.getElementCount() ];
		
		for(int loop=0;loop<condition.getElementCount();loop++)
		{
			results[loop] = isTrue(condition.getElementByIndex(loop));
		}
		
		return results;
	}
	
	public static boolean[] getConditions(XmlElement condition,XmlConditionProcessor processor)
	{
		boolean[] results = new boolean[ condition.getElementCount() ];
		
		for(int loop=0;loop<condition.getElementCount();loop++)
		{
			results[loop] = isTrue(condition.getElementByIndex(loop),processor);
		}
		
		return results;
	}
}
