package org.one.stone.soup.xml.helper;

import org.one.stone.soup.entity.KeyValuePair;
import org.one.stone.soup.xml.*;

/*
 * Wet-Wired.com Xml Helpers Version Date 25-Aug-2004
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

// TODO

public class XmlBuilder {
/**
 * XmlBuilder constructor comment.
 */
private XmlBuilder() {
	super();
}
/**
 *
 */
public static XmlElement getElement(XmlElement node,String name,KeyValuePair[] uniqueKey)
{
	XmlElement found = null;

	for(int loop=0;loop<node.getElementCount();loop++)
	{
		XmlElement child = node.getElementByIndex(loop);
		if(child==null)
			continue;
		if(!child.getName().equals(name))
			continue;

		boolean match = true;
		for(int loopKey=0;loopKey<uniqueKey.length;loopKey++)
		{
			String aValue = child.getAttributeValueByName(uniqueKey[loopKey].key);
			if(aValue==null)
			{
				match=false;
				break;
			}
			if(!aValue.equals(uniqueKey[loopKey].value)) // is this correct ?
			{
				match=false;
				break;
			}
		}

		if(match==true)
		{
			found=child;
			break;
		}
	}

	if(found==null)
		return node.addChild(name);
	else
		return found;
}
/**
 *
 */
public static void setAttribute(XmlElement element,String key, String value)
{
	String attribValue = element.getAttributeValueByName(key);

	if(attribValue==null)
	{
		element.addAttribute(key,value);
	}
	else
	{
		attribValue = value;
	}
}
}
