package org.one.stone.soup.xml.helper;

import java.util.*;
import org.one.stone.soup.xml.*;
import org.one.stone.soup.xml.wrapper.*;

/*
 * Wet-Wired.com Xml Helpers Version Date 25-Aug-2004
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

// TODO
public class XmlCloner {

	private static final int MAX_LEVEL = 20;
private XmlCloner() {
	super();
}
public static XmlElement getClone(XmlElement source)
{
		return getClone(source,true);
}

public static XmlElement getClone(XmlElement source,boolean recursive)
{
		return getClone(source,recursive,0);
}

private static XmlElement getClone(XmlElement source,boolean recursive,int level) {

	if(source instanceof XmlElementWrapper)
	{
		XmlElement newElement = new XmlElement( source.getName() );
		for(int loop=0;loop<source.getAttributeCount();loop++)
		{
			String aName = source.getAttributeNameByIndex(loop);
			String aValue = source.getAttributeValueByIndex(loop);
			newElement.addAttribute(aName,aValue);
		}

		if(!recursive || level>=MAX_LEVEL)
		{
			return newElement;
		}

		XmlElement contents = ((XmlElementWrapper)source).getContents();

		for(int loop=0;loop<contents.getElementCount();loop++)
		{
			if(contents.getElementByIndex(loop)==null)
			{
				newElement.addDataItem( contents.getData(loop) );
			}
			else
			{
				newElement.addChild( getClone(contents.getElementByIndex(loop),recursive,level+1) );
			}
		}

		return newElement;
	}

	XmlElement newElement = new XmlElement(source.getName());

	for(int loop=0;loop<source.getAttributeCount();loop++)
	{
		String aName = source.getAttributeNameByIndex(loop);
		String aValue = source.getAttributeValueByIndex(loop);
		newElement.addAttribute(aName,aValue);
	}

	if(!recursive || level>=MAX_LEVEL)
	{
		return newElement;
	}

	for(int loop=0;loop<source.getElementCount();loop++)
	{
		Object o = source.getData(loop);
		if(o instanceof XmlElement)
		{
			newElement.addChild( getClone( (XmlElement)o,recursive,level+1 ) );
		}
		else if(o instanceof Vector)
		{
			newElement.addDataItem( (Vector)o );
		}
		else if(o instanceof String)
		{
			newElement.addValue( (String)o );
		}
	}

	return newElement;
}

public static XmlElementWrapper getReferenceClone(XmlElement root,XmlElement source,boolean recursive) {

	return getReferenceClone(root,source,recursive,0);
}
private static XmlElementWrapper getReferenceClone(XmlElement root,XmlElement source,boolean recursive,int level) {

	XmlElementWrapper newElement = new XmlElementWrapper(root,source);

	if(!recursive || level>=MAX_LEVEL)
	{
		return newElement;
	}

	for(int loop=0;loop<source.getElementCount();loop++)
	{
		Object o = source.getData(loop);
		if(o instanceof XmlElement)
		{
			newElement.addChild( getReferenceClone( root,(XmlElement)o,recursive,level+1 ) );
		}
		else if(o instanceof Vector)
		{
			newElement.addDataItem( (Vector)o );
		}
		else if(o instanceof String)
		{
			newElement.addValue( (String)o );
		}
	}

	return newElement;
}
}
