package org.one.stone.soup.xml.stream;

import java.io.*;
import java.util.*;

import org.one.stone.soup.xml.*;

/*
 * Wet-Wired.com Xml Version Date 25-Aug-2004
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

// TODO
public class XmlInputStream extends InputStream implements XmlStream{
	private InputStream stream;

	private Vector table = new Vector();

	private static final int BUFFER_SIZE=1000;
	private char[] buffer = new char[BUFFER_SIZE];
	private int bufferEnd = -1;
	private int bufferPos = -1;

	boolean insideTag = false;
	String tagName = null;
/**
 * XmlInputStream constructor comment.
 */
public XmlInputStream(InputStream s) {
	super();
	stream = s;
}
/**
 *
 */
private int _pull()
{
	if(bufferEnd==-1)
		return -1;
	if(bufferPos>=bufferEnd)
		return -1;

	bufferPos++;
	return buffer[bufferPos%BUFFER_SIZE];
}
/**
 *
 * @param b int
 */
private void _push(char b)
{
	bufferEnd++;
	buffer[bufferEnd%BUFFER_SIZE] = b;
}
/**
 *
 * @param b int
 */
private void _push(String s)
{
	for(int loop=0;loop<s.length();loop++)
	{
		_push(s.charAt(loop));
	}
}
/**
 *
 */
private int _read() throws IOException
{
	int b = stream.read();

	switch(b)
	{
		case -1:

			return b;

		case START_TAG:

			insideTag=true;
			b='<';

			int next = read();
			String name="";
			_push( (char)next );
			if(next!=REF)
			{
				while(next!=' ' && next!=-1)
				{
					name += (char)next;
					_push((char)next);
					next = read();
					table.addElement(name);
					System.out.println("Entry:"+name+" added to Input table");
				}
				if(next==-1)
				{
					return -1;
				}
				_push((char)next);
			}
			break;

		case END_TAG:

			insideTag=false;
			b='>';
			break;

		case CLOSE_TAG:

			if(insideTag) // end of empty tag
			{
				_push('>');
				b='/';
			}
			else // end of tag
			{
				_push("/"+tagName+">");
				b='<';
			}
			tagName=null;
			break;

		case REF:

			int index = read();
			String entry = (String)table.elementAt(index);
			if(tagName==null)
				tagName = entry;
			_push( entry );
			break;

		default:
			return b;
	}

	return b;
}
/**
 * read method comment.
 */
public int read() throws IOException {

	int b = _pull();
	if( b==-1 )
		return _read();
	else
		return b;
}
/**
 *
 */
public XmlElement readXmlElement() throws XmlParseException
{
	XmlElement data = XmlLoader.getStandardParser().parseElement(this);

	return data;
}
}
